/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the MailPropertiesEnvelope type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MailPropertiesEnvelope{}

// MailPropertiesEnvelope struct for MailPropertiesEnvelope
type MailPropertiesEnvelope struct {
	RequestId NullableString  `json:"request_id,omitempty"`
	Message   NullableString  `json:"message,omitempty"`
	Data      *MailProperties `json:"data,omitempty"`
}

// NewMailPropertiesEnvelope instantiates a new MailPropertiesEnvelope object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMailPropertiesEnvelope() *MailPropertiesEnvelope {
	this := MailPropertiesEnvelope{}
	return &this
}

// NewMailPropertiesEnvelopeWithDefaults instantiates a new MailPropertiesEnvelope object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMailPropertiesEnvelopeWithDefaults() *MailPropertiesEnvelope {
	this := MailPropertiesEnvelope{}
	return &this
}

// GetRequestId returns the RequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailPropertiesEnvelope) GetRequestId() string {
	if o == nil || IsNil(o.RequestId.Get()) {
		var ret string
		return ret
	}
	return *o.RequestId.Get()
}

// GetRequestIdOk returns a tuple with the RequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailPropertiesEnvelope) GetRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RequestId.Get(), o.RequestId.IsSet()
}

// HasRequestId returns a boolean if a field has been set.
func (o *MailPropertiesEnvelope) HasRequestId() bool {
	if o != nil && o.RequestId.IsSet() {
		return true
	}

	return false
}

// SetRequestId gets a reference to the given NullableString and assigns it to the RequestId field.
func (o *MailPropertiesEnvelope) SetRequestId(v string) {
	o.RequestId.Set(&v)
}

// SetRequestIdNil sets the value for RequestId to be an explicit nil
func (o *MailPropertiesEnvelope) SetRequestIdNil() {
	o.RequestId.Set(nil)
}

// UnsetRequestId ensures that no value is present for RequestId, not even an explicit nil
func (o *MailPropertiesEnvelope) UnsetRequestId() {
	o.RequestId.Unset()
}

// GetMessage returns the Message field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *MailPropertiesEnvelope) GetMessage() string {
	if o == nil || IsNil(o.Message.Get()) {
		var ret string
		return ret
	}
	return *o.Message.Get()
}

// GetMessageOk returns a tuple with the Message field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *MailPropertiesEnvelope) GetMessageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Message.Get(), o.Message.IsSet()
}

// HasMessage returns a boolean if a field has been set.
func (o *MailPropertiesEnvelope) HasMessage() bool {
	if o != nil && o.Message.IsSet() {
		return true
	}

	return false
}

// SetMessage gets a reference to the given NullableString and assigns it to the Message field.
func (o *MailPropertiesEnvelope) SetMessage(v string) {
	o.Message.Set(&v)
}

// SetMessageNil sets the value for Message to be an explicit nil
func (o *MailPropertiesEnvelope) SetMessageNil() {
	o.Message.Set(nil)
}

// UnsetMessage ensures that no value is present for Message, not even an explicit nil
func (o *MailPropertiesEnvelope) UnsetMessage() {
	o.Message.Unset()
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *MailPropertiesEnvelope) GetData() MailProperties {
	if o == nil || IsNil(o.Data) {
		var ret MailProperties
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MailPropertiesEnvelope) GetDataOk() (*MailProperties, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *MailPropertiesEnvelope) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given MailProperties and assigns it to the Data field.
func (o *MailPropertiesEnvelope) SetData(v MailProperties) {
	o.Data = &v
}

func (o MailPropertiesEnvelope) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MailPropertiesEnvelope) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.RequestId.IsSet() {
		toSerialize["request_id"] = o.RequestId.Get()
	}
	if o.Message.IsSet() {
		toSerialize["message"] = o.Message.Get()
	}
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	return toSerialize, nil
}

type NullableMailPropertiesEnvelope struct {
	value *MailPropertiesEnvelope
	isSet bool
}

func (v NullableMailPropertiesEnvelope) Get() *MailPropertiesEnvelope {
	return v.value
}

func (v *NullableMailPropertiesEnvelope) Set(val *MailPropertiesEnvelope) {
	v.value = val
	v.isSet = true
}

func (v NullableMailPropertiesEnvelope) IsSet() bool {
	return v.isSet
}

func (v *NullableMailPropertiesEnvelope) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMailPropertiesEnvelope(val *MailPropertiesEnvelope) *NullableMailPropertiesEnvelope {
	return &NullableMailPropertiesEnvelope{value: val, isSet: true}
}

func (v NullableMailPropertiesEnvelope) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMailPropertiesEnvelope) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
